#include "binheap.h"

#include <stdio.h>
#include <stdlib.h>
#include <assert.h>
#include <malloc.h>
#include <limits.h>		// For INT_MIN

void bhInit(BinaryHeap *heap, unsigned int max_size)
{
	assert(heap != NULL);

	heap->data = (Type *)calloc(max_size + 1, sizeof(Type));
	if (heap->data == NULL) {
		fprintf(stderr, "Memory Allocation Error!\nExiting Program...\n\n");
		exit(1);
	}
	heap->max_size = max_size;
	heap->current_size = 0;
	heap->data[0] = INT_MIN;
}

void bhDestroy(BinaryHeap *heap)
{
	assert(heap != NULL);

	if (heap->data != NULL)
		free(heap->data);
	heap->data = NULL;
	heap->max_size = 0;
	heap->current_size = 0;
}

void bhInsert(BinaryHeap *heap, Type value)
{
	int i;

	assert(heap != NULL);


}


Type bhDeleteMin(BinaryHeap *heap)
{
	unsigned int i = 0, child = 0;
	Type min = 0, last = 0;

	assert(heap != NULL);

	return min;
}


BOOL bhIsEmpty(BinaryHeap *heap)
{
	assert(heap != NULL);
	if (heap->current_size == 0)
		return TRUE;
	else
		return FALSE;
}

BOOL bhIsFull(BinaryHeap *heap)
{
	assert(heap != NULL);
	
	if (heap->current_size == heap->max_size)
		return TRUE;
	else
		return FALSE;

}

void bhPrint(BinaryHeap *heap)
{
	unsigned int i = 0;

	assert(heap != NULL);

	for (i = 0; i < heap->current_size; i++)
	{
		fprintf(stdout, TYPE_MODIFIER" ", heap->data[i]);
	}
	fprintf(stdout, "\n");

}