#ifndef __BINHEAP_H__
#define __BINHEAP_H__

#include "defns.h"

/**
 * Structure for a Binary Heap.
 */
typedef struct _BinaryHeap {
	Type *data;						// Storage for the data
	unsigned int current_size;		// The current size of the heap
	unsigned int max_size;			// The maximum allowed size for this heap
} BinaryHeap;

// Initialize a heap
void bhInit(BinaryHeap *heap, unsigned int max_size);
// Destroy the contents of the heap
void bhDestroy(BinaryHeap *heap);
// Insert some data in the heap
void bhInsert(BinaryHeap *heap, Type value);
// Delete the minimum value from the heap
Type bhDeleteMin(BinaryHeap *heap);
// Is the heap empty?
BOOL bhIsEmpty(BinaryHeap *heap);
// Is the heap full?
BOOL bhIsFull(BinaryHeap *heap);
// Print the contents of the heap
void bhPrint(BinaryHeap *heap);


#endif // __BINHEAP_H__